// Code generated by go-swagger; DO NOT EDIT.

package virtual_machines

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// VMListHandlerFunc turns a function with the right signature into a vm list handler
type VMListHandlerFunc func(VMListParams) middleware.Responder

// Handle executing the request and returning a response
func (fn VMListHandlerFunc) Handle(params VMListParams) middleware.Responder {
	return fn(params)
}

// VMListHandler interface for that can handle valid vm list params
type VMListHandler interface {
	Handle(VMListParams) middleware.Responder
}

// NewVMList creates a new http.Handler for the vm list operation
func NewVMList(ctx *middleware.Context, handler VMListHandler) *VMList {
	return &VMList{Context: ctx, Handler: handler}
}

/*VMList swagger:route GET /api/vms Virtual machines vmList

Get virtual machine list

*/
type VMList struct {
	Context *middleware.Context
	Handler VMListHandler
}

func (o *VMList) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewVMListParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
